<?php

namespace Factory;

use Zeedhi\DevOps\Model\Configurationmanager\Entities\DeployStep as DeployStepEntity;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\DeployStepServer;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\Deploy as DeployEntity;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\Product as ProductEntity;
use Zeedhi\DevOps\Model\Servermanager\Entities\ProductServer as ProductServerEntity;
use Zeedhi\DevOps\Model\Devops\Entities\ProductVersion;

class DeployStep {
    public function save(DeployStepEntity $deployStep = null, ProductEntity $product, ProductVersion $productVersion,
                         $status, $isActive, $description, $cdcliente) {
        if(empty($deployStep)) {
            $deployStep = new DeployStepEntity();
        }

        $deployStep->setDescription($description);
        $deployStep->setProduct($product);
        $deployStep->setProductVersion($productVersion);
        $deployStep->setIsActive($isActive);
        $deployStep->setStatus($status);
        $deployStep->setCdcliente($cdcliente);

        return $deployStep;
    }

    public function saveServer(DeployStepServer $deployStepServer = null, DeployStepEntity $deployStep, ProductServerEntity $productServer,
                               $order, DeployEntity $deploy = null, $isActive = 'Y') {
        if(empty($deployStepServer)) {
            $deployStepServer = new DeployStepServer();
        }

        $deployStepServer->setDeployStep($deployStep);
        $deployStepServer->setProductServer($productServer);
        $deployStepServer->setServerOrder($order);
        $deployStepServer->setIsActive($isActive);

        if($deploy) {
            $deployStepServer->setDeploy($deploy);
        }

        return $deployStepServer;
    }
}
