<?php

namespace Service;

use Doctrine\ORM\EntityManager;
use Exception\CustomException;
use Util\DateUtil;
use \Teknisa\Model\Geral\Entities\Operador;
use Util\Utilities;
use Util\InstanceProvider;
use Zeedhi\DevOps\Model\Profile\Entities\ZhUser;


class Faturamento {

    /** @var EntityManager $entityManager */
    protected  $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    /**
     * @param $conditions
     * @param $nrorg
     * @param $nrparcnegocio
     * @param $dtinicompet
     * @param $dtfincompet
     * @return array
     */
    public function find($conditions, $nrorg, $nrparcnegocio, $dtinicompet, $dtfincompet, $page, $pageSize, $orderBy = null)
    {
        $limit = $page * $pageSize;
        $orderString = 'ORDER BY DTINICOMPET ASC, NRSEQCONTRATO';
        $offset = ($page - 1) * $pageSize;
        foreach($conditions as &$condition){
            if($condition["columnName"] == "DTFINCOMPET"){
                $condition["operator"] = "<=";
                $condition['value'] = "'" . $condition['value'] . "'";
            }
            if($condition["columnName"] == "DTINICOMPET"){
                $condition["operator"] = ">=";
                $condition['value'] = "'" . $condition['value'] . "'";
            }
        }
        $filter = InstanceProvider::getUtilities()->createQueryFiltered($conditions);
        if($orderBy){
            foreach($orderBy as $idx => $order) {
                $orderString = 'ORDER BY ' . $idx . ' ' . $order;
            }
        }
        $dtinicompetFilter = '';
        $dtfincompetFilter = '';
        $dtinicompetFilterMed = '';
        $dtfincompetFilterMed = '';
        if($dtinicompet){
            $dtinicompetFilter = "AND (TRUNC(TO_DATE('{$dtinicompet}', 'DD/MM/YYYY')) < TRUNC(FAT.DTINICOMPET) OR TRUNC(TO_DATE('{$dtinicompet}', 'DD/MM/YYYY')) < TRUNC(FAT.DTFINCOMPET))";
            $dtinicompetFilterMed = "AND (TRUNC(TO_DATE('{$dtinicompet}', 'DD/MM/YYYY')) < TRUNC(MED.DTINICOMPET) OR TRUNC(TO_DATE('{$dtinicompet}', 'DD/MM/YYYY')) < TRUNC(MED.DTFINCOMPET))";
        }
        if($dtfincompet){
            $dtfincompetFilter = "AND (TRUNC(TO_DATE('{$dtfincompet}', 'DD/MM/YYYY')) > TRUNC(FAT.DTINICOMPET) OR TRUNC(TO_DATE('{$dtfincompet}', 'DD/MM/YYYY')) > TRUNC(FAT.DTFINCOMPET))";
            $dtfincompetFilterMed = "AND (TRUNC(TO_DATE('{$dtfincompet}', 'DD/MM/YYYY')) > TRUNC(MED.DTINICOMPET) OR TRUNC(TO_DATE('{$dtfincompet}', 'DD/MM/YYYY')) > TRUNC(MED.DTFINCOMPET))";
        }
        return InstanceProvider::getRepository()->getParcnegocio()->getFaturamentoContrato($filter, $dtinicompetFilter, $dtfincompetFilter, $dtinicompetFilterMed, $dtfincompetFilterMed, $nrorg, $nrparcnegocio, $limit, $offset, $orderString);
    }


    public function findBilletIssuedFct($nrlanctonf){
        return InstanceProvider::getRepository()->getParcnegocio()->findBilletIssuedFct($nrlanctonf);
    }

}
