<?php
namespace Zeedhi\DevOps\Model\Projectmanagement\Entities\Base;


abstract class Task {


    /** @var \Datetime  */
    protected $beginDate;
    /** @var \Datetime  */
    protected $commitmentDate;
    /** @var \Datetime  */
    protected $createdAt;
    /** @var \Datetime  */
    protected $createdAtInProject;
    /** @var int  */
    protected $createdBy;
    /** @var \Datetime  */
    protected $currentTaskStatusIn;
    /** @var \Datetime  */
    protected $dateException;
    /** @var string  */
    protected $dateExceptionType;
    /** @var string  */
    protected $description;
    /** @var \Zeedhi\DevOps\Model\Devops\Entities\ProductVersion  */
    protected $productVersion;
    /** @var \Zeedhi\DevOps\Model\Devops\Entities\ProductVersion  */
    protected $productVersionDev;
    /** @var int  */
    protected $menuItem;
    /** @var int  */
    protected $duration;
    /** @var \Datetime  */
    protected $endDate;
    /** @var string  */
    protected $errorMessage;
    /** @var \Datetime  */
    protected $estimatedBeginDate;
    /** @var \Datetime  */
    protected $estimatedEndDate;
    /** @var int  */
    protected $id;
    /** @var string  */
    protected $inCalc = 'N';
    /** @var string  */
    protected $isIssue = 'N';
    /** @var string  */
    protected $isParent = 'N';
    /** @var int  */
    protected $latency;
    /** @var string  */
    protected $name;
    /** @var int  */
    protected $organization;
    /** @var int  */
    protected $percentCompleted = 0;
    /** @var int  */
    protected $previousTime = 0;
    /** @var int  */
    protected $progress;
    /** @var string  */
    protected $response;
    /** @var string  */
    protected $status = 'A';
    /** @var int  */
    protected $timePlanned = 0;
    /** @var int  */
    protected $timeRemaining;
    /** @var int  */
    protected $timeScore;
    /** @var int  */
    protected $timeSpent;
    /** @var string  */
    protected $treeKey;
    /** @var \Datetime  */
    protected $updatedAt;
    /** @var int  */
    protected $updatedBy;
    /** @var string  */
    protected $urlToTest;
    /** @var string  */
    protected $usedInFraming = 'Y';
    /** @var int  */
    protected $taskOrder;
    /** @var string  */
    protected $isOriginalBaseline;
    /** @var string  */
    protected $baselineOccurrence;
    /** @var string  */
    protected $testBlocked = 'N';
    /** @var string  */
    protected $baselineOccurrenceAt;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Allocation[]  */
    protected $allocations = array (
);
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Calendar  */
    protected $calendar;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Classification  */
    protected $classification;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\ErrorClassification  */
    protected $errorClassification;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Task  */
    protected $parent;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Priority  */
    protected $priority;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Project  */
    protected $project;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\Task[]  */
    protected $subTasks = array (
);
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskBranches[]  */
    protected $taskBranches = array (
);
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskFeatures  */
    protected $taskFeatures;
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskRelationship[]  */
    protected $taskRelationship = array (
);
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskRelationship[]  */
    protected $taskRelationshipInverse = array (
);
    /** @var \Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskStatus  */
    protected $taskStatus;

    public function getBeginDate() {
        return $this->beginDate;
    }
	public function setBeginDate(\Datetime $beginDate = NULL) {
        $this->beginDate = $beginDate;
    }
	public function getCommitmentDate() {
        return $this->commitmentDate;
    }
	public function setCommitmentDate(\Datetime $commitmentDate = NULL) {
        $this->commitmentDate = $commitmentDate;
    }
	public function getCreatedAt() {
        return $this->createdAt;
    }
	public function setCreatedAt(\Datetime $createdAt) {
        $this->createdAt = $createdAt;
    }
	public function getCreatedAtInProject() {
        return $this->createdAtInProject;
    }
	public function setCreatedAtInProject(\Datetime $createdAtInProject = NULL) {
        $this->createdAtInProject = $createdAtInProject;
    }
	public function getCreatedBy() {
        return $this->createdBy;
    }
	public function setCreatedBy($createdBy) {
        $this->createdBy = $createdBy;
    }
	public function getCurrentTaskStatusIn() {
        return $this->currentTaskStatusIn;
    }
	public function setCurrentTaskStatusIn(\Datetime $currentTaskStatusIn = NULL) {
        $this->currentTaskStatusIn = $currentTaskStatusIn;
    }
	public function getDateException() {
        return $this->dateException;
    }
	public function setDateException(\Datetime $dateException = NULL) {
        $this->dateException = $dateException;
    }
	public function getDateExceptionType() {
        return $this->dateExceptionType;
    }
	public function setDateExceptionType($dateExceptionType = NULL) {
        $this->dateExceptionType = $dateExceptionType;
    }
	public function getDescription() {
        return $this->description;
    }
	public function setDescription($description = NULL) {
        $this->description = $description;
    }
	public function getDuration() {
        return $this->duration;
    }
	public function setDuration($duration = NULL) {
        $this->duration = $duration;
    }
	public function getEndDate() {
        return $this->endDate;
    }
	public function setEndDate(\Datetime $endDate = NULL) {
        $this->endDate = $endDate;
    }
	public function getErrorMessage() {
        return $this->errorMessage;
    }
	public function setErrorMessage($errorMessage = NULL) {
        $this->errorMessage = $errorMessage;
    }
	public function getEstimatedBeginDate() {
        return $this->estimatedBeginDate;
    }
	public function setEstimatedBeginDate(\Datetime $estimatedBeginDate = NULL) {
        $this->estimatedBeginDate = $estimatedBeginDate;
    }
	public function getEstimatedEndDate() {
        return $this->estimatedEndDate;
    }
	public function setEstimatedEndDate(\Datetime $estimatedEndDate = NULL) {
        $this->estimatedEndDate = $estimatedEndDate;
    }
	public function getId() {
        return $this->id;
    }
	public function setId($id) {
        $this->id = $id;
    }
	public function getInCalc() {
        return $this->inCalc;
    }
	public function setInCalc($inCalc) {
        $this->inCalc = $inCalc;
    }
	public function getIsIssue() {
        return $this->isIssue;
    }
	public function setIsIssue($isIssue = NULL) {
        $this->isIssue = $isIssue;
    }
	public function getIsParent() {
        return $this->isParent;
    }
	public function setIsParent($isParent) {
        $this->isParent = $isParent;
    }
	public function getLatency() {
        return $this->latency;
    }
	public function setLatency($latency = NULL) {
        $this->latency = $latency;
    }
	public function getName() {
        return $this->name;
    }
	public function setName($name = NULL) {
        $this->name = $name;
    }
	public function getOrganization() {
        return $this->organization;
    }
	public function setOrganization($organization) {
        $this->organization = $organization;
    }
	public function getPercentCompleted() {
        return $this->percentCompleted;
    }
	public function setPercentCompleted($percentCompleted) {
        $this->percentCompleted = $percentCompleted;
    }
	public function getPreviousTime() {
        return $this->previousTime;
    }
	public function setPreviousTime($previousTime = NULL) {
        $this->previousTime = $previousTime;
    }
	public function getProgress() {
        return $this->progress;
    }
	public function setProgress($progress = NULL) {
        $this->progress = $progress;
    }
	public function getResponse() {
        return $this->response;
    }
	public function setResponse($response = NULL) {
        $this->response = $response;
    }
	public function getStatus() {
        return $this->status;
    }
	public function setStatus($status = NULL) {
        $this->status = $status;
    }
	public function getTimePlanned() {
        return $this->timePlanned;
    }
	public function setTimePlanned($timePlanned = NULL) {
        $this->timePlanned = $timePlanned;
    }
	public function getTimeRemaining() {
        return $this->timeRemaining;
    }
	public function setTimeRemaining($timeRemaining = NULL) {
        $this->timeRemaining = $timeRemaining;
    }
	public function getTimeScore() {
        return $this->timeScore;
    }
	public function setTimeScore($timeScore = NULL) {
        $this->timeScore = $timeScore;
    }
	public function getTimeSpent() {
        return $this->timeSpent;
    }
	public function setTimeSpent($timeSpent = NULL) {
        $this->timeSpent = $timeSpent;
    }
	public function getTreeKey() {
        return $this->treeKey;
    }
	public function setTreeKey($treeKey = NULL) {
        $this->treeKey = $treeKey;
    }
	public function getUpdatedAt() {
        return $this->updatedAt;
    }
	public function setUpdatedAt(\Datetime $updatedAt) {
        $this->updatedAt = $updatedAt;
    }
	public function getUpdatedBy() {
        return $this->updatedBy;
    }
	public function setUpdatedBy($updatedBy = NULL) {
        $this->updatedBy = $updatedBy;
    }
	public function getUrlToTest() {
        return $this->urlToTest;
    }
	public function setUrlToTest($urlToTest = NULL) {
        $this->urlToTest = $urlToTest;
    }
	public function getMenuItem() {
        return $this->menuItem;
    }
	public function setMenuItem($menuItem = NULL) {
        $this->menuItem = $menuItem;
    }
	public function getProductVersion() {
        return $this->productVersion;
    }
	public function setProductVersion(\Zeedhi\DevOps\Model\Devops\Entities\ProductVersion $productVersion = NULL) {
        $this->productVersion = $productVersion;
    }
	public function getProductVersionDev() {
        return $this->productVersionDev;
    }
	public function setProductVersionDev(\Zeedhi\DevOps\Model\Devops\Entities\ProductVersion $productVersionDev = NULL) {
        $this->productVersionDev = $productVersionDev;
    }
	public function getUsedInFraming() {
        return $this->usedInFraming;
    }
	public function setUsedInFraming($usedInFraming) {
        $this->usedInFraming = $usedInFraming;
    }
	public function getTaskOrder() {
        return $this->taskOrder;
    }
	public function setTaskOrder($taskOrder = NULL) {
        $this->taskOrder = $taskOrder;
    }
    public function getIsOriginalBaseline() {
        return $this->isOriginalBaseline;
    }
    public function setIsOriginalBaseline($isOriginalBaseline = NULL) {
        $this->isOriginalBaseline = $isOriginalBaseline;
    }
    public function getBaselineOccurrence() {
        return $this->baselineOccurrence;
    }
    public function setBaselineOccurrence($baselineOccurrence = NULL) {
        $this->baselineOccurrence = $baselineOccurrence;
    }
    public function getBaselineOccurrenceAt() {
        return $this->baselineOccurrenceAt;
    }
    public function setBaselineOccurrenceAt($baselineOccurrenceAt = NULL) {
        $this->baselineOccurrenceAt = $baselineOccurrenceAt;
    }
	public function __construct() {
        $this->createdAt = new \DateTime();
		$this->updatedAt = new \DateTime();
		$this->createdAtInProject = new \DateTime();
    }
	public function getAllocations() {
        return $this->allocations;
    }
	public function addAllocation(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Allocation $allocation) {
        $this->allocations[] = $allocation;
    }
	public function getCalendar() {
        return $this->calendar;
    }
	public function setCalendar(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Calendar $calendar = NULL) {
        $this->calendar = $calendar;
    }
	public function getClassification() {
        return $this->classification;
    }
	public function setClassification(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Classification $classification = NULL) {
        $this->classification = $classification;
    }
	public function getErrorClassification() {
        return $this->errorClassification;
    }
	public function setErrorClassification(\Zeedhi\DevOps\Model\Projectmanagement\Entities\ErrorClassification $errorClassification = NULL) {
        $this->errorClassification = $errorClassification;
    }
	public function getParent() {
        return $this->parent;
    }
	public function setParent(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Task $parent = NULL) {
        $this->parent = $parent;
    }
	public function getPriority() {
        return $this->priority;
    }
	public function setPriority(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Priority $priority = NULL) {
        $this->priority = $priority;
    }
	public function getProject() {
        return $this->project;
    }
	public function setProject(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Project $project = NULL) {
        $this->project = $project;
    }
	public function getSubTasks() {
        return $this->subTasks;
    }
	public function addSubTask(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Task $subTask) {
        $this->subTasks[] = $subTask;
    }
	public function getTaskBranches() {
        return $this->taskBranches;
    }
	public function addTaskBranch(\Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskBranches $taskBranch) {
        $this->taskBranches[] = $taskBranch;
    }
	public function getTaskFeatures() {
        return $this->taskFeatures;
    }
	public function setTaskFeatures(\Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskFeatures $taskFeatures = NULL) {
        $this->taskFeatures = $taskFeatures;
    }
	public function getTaskRelationship() {
        return $this->taskRelationship;
    }
	public function addTaskRelationship(\Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskRelationship $taskRelationship) {
        $this->taskRelationship[] = $taskRelationship;
    }
	public function getTaskRelationshipInverse() {
        return $this->taskRelationshipInverse;
    }
	public function addTaskRelationshipInverse(\Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskRelationship $taskRelationshipInverse) {
        $this->taskRelationshipInverse[] = $taskRelationshipInverse;
    }
	public function getTaskStatus() {
        return $this->taskStatus;
    }
	public function setTaskStatus(\Zeedhi\DevOps\Model\Projectmanagement\Entities\TaskStatus $taskStatus = NULL) {
        $this->taskStatus = $taskStatus;
    }
	public function getTestBlocked() {
        return $this->testBlocked;
    }
	public function setTestBlocked($testBlocked) {
        $this->testBlocked = $testBlocked;
    }
}